<?php
define('IN_SAS', true);

$docroot = strtolower ( getenv ( 'DOCUMENT_ROOT' ) ) ;
$path = htmlentities(dirname($_SERVER['PHP_SELF']));
$user_path = str_replace('starnet/core', '' , $path);

include ($docroot . $user_path . 'starnet/configuration/database.inc.php'); // connecting to database // connecting to database
$db = new mysqli($db_server, $db_username, $db_password, $db_name);
require ("session.php"); //build a session

unset ($sas_config); //clear the config array first
$query = "SELECT config_key,config_value FROM $table_configuration";
//read all the configuration items.

$result = mysqli_query($db, $query);
while ($config_list = mysqli_fetch_array($result))
{
	$sas_config[$config_list[0]] = $config_list[1]; //put them in the config array
}
$check_sessioncode = $sas_config['sessioncode'];
$sitename = $sas_config['sitename'];
$sitename = remove_special_characters($sitename) ;	//remove special characters for the name

if ($_SESSION['sessioncode'] != $check_sessioncode)
{
	//if we don't have a session present the login screen
	Header("Location: ../index.php");
	exit;
}


header("Pragma: no-cache");
$file_date = date("Ymd_Gi");
header("Content-Type: text/x-delimtext; name=\"".$sitename."_". $file_date.".sql\"");
header("Content-disposition: attachment; filename=\"".$sitename."_".$file_date.".sql\"");

$table_name = $dbprefix . "m_template_css";
echo "TRUNCATE $table_name;||";
//get get contents for this table
get_table_content_mysql($table_name, "output_table_content");
$table_name = $dbprefix . "fonts";
echo "TRUNCATE $table_name;||";
//get get contents for this table
get_table_content_mysql($table_name, "output_table_content");
$table_name = $dbprefix . "m_slider";
echo "TRUNCATE $table_name;||";
//get get contents for this table
get_table_content_mysql($table_name, "output_table_content");
//get the config options for slider and template itself
echo "DELETE FROM $table_configuration WHERE config_key LIKE 'slider_%' OR config_key LIKE 'template_%';||";
$where = "WHERE config_key LIKE 'slider_%' OR config_key LIKE 'template_%'";
get_config_content_mysql($table_configuration, "output_table_content",$where);

//get the content for the invisible section
echo "INSERT INTO $table_sections (id, name, invisible, frontpage, parent, sort) VALUES (99, 'Onzichtbare sectie', 'yes', 900, '', 99);||\n";
echo "DELETE FROM $table_pages WHERE section = 99;||\n";
$where = "WHERE section = 99";
get_config_content_mysql($table_pages, "output_table_content", $where);

function get_config_content_mysql($table, $handler, $where)
{
	global $db;
	//
	// Grab the data from the table.
	//
	$result = mysqli_query($db, "SELECT * FROM $table $where");

	if (sql_numrows($result) > 0)
	{
		$schema_insert = "\n#\n# Table Data for $table\n#\n";
	}
	else
	{
		$schema_insert = "";
	}

	$handler ($schema_insert);

	//
	// Loop through the resulting rows and build the sql statement.
	//

	while ($row = sql_fetchrow($result))
	{
		$table_list = '(';
		$num_fields = sql_numfields($result);
		//
		// Grab the list of field names.
		//
		for ($j = 0; $j < $num_fields; $j++)
		{
			$table_list .= sql_fieldname($j, $result) . ', ';
		}
		//
		// Get rid of the last comma
		//
		$table_list = preg_replace('/, $/', '', $table_list);
		$table_list .= ')';
		//
		// Start building the SQL statement.
		//
		$schema_insert = "INSERT INTO $table $table_list VALUES(";
		//
		// Loop through the rows and fill in data for each column
		//
		
		for ($j = 0; $j < $num_fields; $j++)
		{
			if (!isset ($row[$j]))
			{
				//
				// If there is no data for the column set it to null.
				// There was a problem here with an extra space causing the
				// sql file not to reimport if the last column was null in
				// any table.  Should be fixed now :) JLH
				//
				$schema_insert .= ' NULL,';
			}
			elseif ($row[$j] != '')
			{
				$schema_insert .= ' \'' . addslashes($row[$j]) . '\',';
			}
			else
			{
				$schema_insert .= '\'\',';
			}
		}
		//
		// Get rid of the the last comma.
		//
		$schema_insert = preg_replace('/,$/', '', $schema_insert);
		$schema_insert .= ');';
		//
		// Go ahead and send the insert statement to the handler function.
		//
		$handler (trim($schema_insert));

	}
	return (true);
}
function get_table_content_mysql($table, $handler)
{
	global $db;
	//
	// Grab the data from the table.
	//
	$result = mysqli_query($db, "SELECT * FROM $table");

	if (!$result)
	{
		trigger_error(mysqli_error($db).'"<br>Query : "SELECT * FROM $table"',E_USER_WARNING); 
	}

	if (sql_numrows($result) > 0)
	{
		$schema_insert = "\n#\n# Table Data for $table\n#\n";
	}
	else
	{
		$schema_insert = "";
	}

	$handler ($schema_insert);

	//
	// Loop through the resulting rows and build the sql statement.
	//

	while ($row = sql_fetchrow($result))
	{
		$table_list = '(';
		$num_fields = sql_numfields($result);

		//
		// Grab the list of field names.
		//
		for ($j = 0; $j < $num_fields; $j++)
		{
			$table_list .= sql_fieldname($j, $result) . ', ';
		}
		//
		// Get rid of the last comma
		//
		$table_list = preg_replace('/, $/', '', $table_list);
		$table_list .= ')';
		//
		// Start building the SQL statement.
		//
		$schema_insert = "INSERT INTO $table $table_list VALUES(";
		//
		// Loop through the rows and fill in data for each column
		//
		for ($j = 0; $j < $num_fields; $j++)
		{
			if (!isset ($row[$j]))
			{
				//
				// If there is no data for the column set it to null.
				// There was a problem here with an extra space causing the
				// sql file not to reimport if the last column was null in
				// any table.  Should be fixed now :) JLH
				//
				$schema_insert .= ' NULL,';
			}
			elseif ($row[$j] != '')
			{
				$schema_insert .= ' \'' . addslashes($row[$j]) . '\',';
			}
			else
			{
				$schema_insert .= '\'\',';
			}
		}
		//
		// Get rid of the the last comma.
		//
		$schema_insert = preg_replace('/,$/', '', $schema_insert);
		$schema_insert .= ');';
		//
		// Go ahead and send the insert statement to the handler function.
		//
		$handler (trim($schema_insert));

	}
	return (true);
}
function sql_fetchrow($query_id = 0)
{
	global $db;
	
	if (!$query_id)
	{
		$query_id = $this->query_result;
	}
	if ($query_id)
	{
		$row = mysqli_fetch_array($query_id);
		//$this->row[$query_id] = @mysqli_fetch_array($query_id);		
		//return $this->row[$query_id];
		return $row;
	}
	else
	{
		return false;
	}
}
function sql_fieldname($offset, $query_id = 0)
{
	global $db;
	
	if (!$query_id)
	{
		$query_id = $this->query_result;
	}
	if ($query_id)
	{
		$result = mysqli_fetch_field_direct($query_id, $offset);
		return $result->name;
	}
	else
	{
		return false;
	}
}
function sql_numfields($query_id = 0)
{
	global $db;
	
	if (!$query_id)
	{
		$query_id = $this->query_result;
	}
	if ($query_id)
	{
		$result = mysqli_field_count($db);
		return $result;
	}
	else
	{
		return false;
	}
}
function sql_numrows($query_id = 0)
{
	global $db;
		
	if (!$query_id)
	{
		$query_id = $this->query_result;
	}
	if ($query_id)
	{
		$count = @ mysqli_num_rows($query_id);
		return $count;
	}
	else
	{
		return false;
	}
}

function output_table_content($content)
{
	global $tempfile;
	echo $content . "||\n";
	return;
}
function remove_special_characters($string)
{
	# Remove spaces, apostrophe, exclamation marks  and replace them with underscore
	$str_from = "% \'+@!,\t\*?`\"/;:&()";
	$str_to = str_repeat("_", strlen($str_from));
	//return strtr(stripslashes($string), $str_from, $str_to);
	$string = strtr(stripslashes($string), $str_from, $str_to);
	$lastDot = strrpos($string, "."); //get last position of point
	$string = str_replace(".", "", substr($string, 0, $lastDot)) . substr($string, $lastDot);
	return $string;
} // end of the 'remove_special_characters2()' function
?>